# EVPN Multi-Homing Inventory

This repository holds all the configurations for a standardized deployment using the following technologies:

* BGP underlay
* VXLAN encapsulation server connectivity
* EVPN Multihoming mode control plane
* Distributed gateway routing, with SVI as gateways living on border leafs


## Demo architecture

### IPAM

Servers are configured for access vlan. The servers use a route for 10.0.0.0/8 pointing to the firewall (10.1.<VLAN#>.1).

#### Server IPs
```
{% for device in hostvars[inventory_hostname]['evpn_mh_server01']['devices']|default([]) %}
{{ device }}
  vlan {{ hostvars[inventory_hostname]['evpn_mh_' + device]['devices'][device].bond.vlan }}
    {{ hostvars[inventory_hostname]['evpn_mh_' + device]['devices'][device].bond.ip }}
{% endfor %}
```
#### Switch IPs
```
{% for device in ['leaf01', 'leaf02', 'leaf03', 'leaf04', 'border01', 'border02']%}
{{ device }}
{%   for vlan in hostvars[inventory_hostname]['evpn_mh_' + device]['vlans']|default([]) if vlan.address is defined or vlan.address_virtual is defined %}
  vlan {{ vlan.id }}
{%     for address in vlan.address|default([])+vlan.address_virtual|default([]) %}
    {{ address }} vrf {{ vlan.vrf|default('default') }}
{%     endfor %}
{%   else %}
{%   endfor %}
{% endfor %}
```


### Features

This automation repo is used to demonstrate the following features:
 * BGP unnumbered underlay fabric
 * VXLAN overlay encapsulation data plane
 * EVPN overlay control plane
 * EVPN-PIM for BUM traffic
 * EVPN Multi-homing to replace MLAG

### PTM

```
cumulus@border01:mgmt:~$ sudo ptmctl -dl
---------------------------------------------------------------------------------------------------------------------
port   cbl     exp             act             sysname   portID  portDescr                  match   last
       status  nbr             nbr                                                          on      upd
---------------------------------------------------------------------------------------------------------------------
swp51  pass    spine01:swp5    spine01:swp5    spine01   swp5    to leaf                    IfName  14d:10h:27m:59s
swp50  pass    border02:swp50  border02:swp50  border02  swp50   bond member of rp_link     IfName  10d:8h:18m:30s
swp49  pass    border02:swp49  border02:swp49  border02  swp49   bond member of rp_link     IfName  10d:8h:18m:30s
swp52  pass    spine02:swp5    spine02:swp5    spine02   swp5    to leaf                    IfName  10d:8h:18m:27s
swp53  pass    spine03:swp5    spine03:swp5    spine03   swp5    to leaf                    IfName  10d:8h:18m:27s
swp54  pass    spine04:swp5    spine04:swp5    spine04   swp5    to leaf                    IfName  10d:8h:18m:11s
swp3   pass    fw1:swp1        fw1:swp1        fw1       swp1    bond member of borderBond  IfName  4h:21m:33s
```

## Automation

### Ansible

Prerequisites:
- Cumulus Linux Reference Topology (cldemo2) has already been started and is running
- From a shell session on the oob-mgmt-server inside of the simulation

**Note: If you used the start-script.sh to start the simulation, the directory is already present on the oob-mgmt-server**

1) Clone the repo
```
git clone https://gitlab.com/cumulus-consulting/goldenturtle/cumulus_ansible_modules.git && cd cumulus_ansible_modules
```

2) Test ansible
```
ansible all -i inventories/evpn_mh/hosts -m ping
```

3) Run the ansible playbook to deploy the demo to the fabric
```
ansible-playbook playbooks/deploy.yml -i inventories/evpn_mh/hosts --diff
```

### Playbook Structure

The playbooks have the following important structure:
* Variables and inventories are stored in the same directory `inventories/`
* Backup configurations are stored in `configs/`
<!-- AIR:tour -->
## Validate

### Server to Server connectivity

Log into `server01`:
```
cumulus@oob-mgmt-server:~$ ssh server01
Warning: Permanently added 'server01' (ECDSA) to the list of known hosts.
Welcome to Ubuntu 18.04.3 LTS (GNU/Linux 4.15.0-70-generic x86_64)

 * Documentation:  https://help.ubuntu.com
 * Management:     https://landscape.canonical.com
 * Support:        https://ubuntu.com/advantage

  System information as of Mon Nov 25 15:27:42 PST 2019

  System load:  0.0               Processes:             83
  Usage of /:   18.7% of 9.29GB   Users logged in:       0
  Memory usage: 12%               IP address for eth0:   192.168.200.14
  Swap usage:   0%                IP address for uplink: 10.1.10.101

 * Overheard at KubeCon: "microk8s.status just blew my mind".

     https://microk8s.io/docs/commands#microk8s.status

23 packages can be updated.
0 updates are security updates.


Last login: Mon Nov 25 15:00:38 2019 from 192.168.200.1
cumulus@server01:~$
```

Ping `server04` from `server01` to validate L2 intra-VLAN connectivity:
```
cumulus@server01:~$ ping 10.1.10.104
PING 10.1.10.104 (10.1.10.104) 56(84) bytes of data.
64 bytes from 10.1.10.104: icmp_seq=1 ttl=64 time=7.68 ms
64 bytes from 10.1.10.104: icmp_seq=2 ttl=64 time=4.32 ms
^C
--- 10.1.10.104 ping statistics ---
2 packets transmitted, 2 received, 0% packet loss, time 1002ms
rtt min/avg/max/mdev = 4.324/6.002/7.680/1.678 ms
```

Ping `server02` from `server01` to validate L3 inter-VLAN connectivity:
```
cumulus@server01:~$ ping 10.1.20.102
PING 10.1.20.102 (10.1.20.102) 56(84) bytes of data.
64 bytes from 10.1.20.102: icmp_seq=1 ttl=63 time=8.20 ms
64 bytes from 10.1.20.102: icmp_seq=2 ttl=63 time=5.61 ms
^C
--- 10.1.20.102 ping statistics ---
2 packets transmitted, 2 received, 0% packet loss, time 1001ms
rtt min/avg/max/mdev = 5.614/6.910/8.206/1.296 ms
```

Ping `server03` from `server01` to validate L3 inter-VLAN connectivity is not allowed between VRF:
```
cumulus@server01:~$ ping 10.1.30.103
PING 10.1.30.103 (10.1.30.103) 56(84) bytes of data.
From 10.1.10.3 icmp_seq=1 Destination Host Unreachable
From 10.1.10.3 icmp_seq=2 Destination Host Unreachable
^C
--- 10.1.30.103 ping statistics ---
2 packets transmitted, 0 received, +2 errors, 100% packet loss, time 1032ms
```

Log into `leaf01`:
```
cumulus@server01:~$ exit
logout
Connection to server01 closed.
cumulus@oob-mgmt-server:~/cumulus_ansible_modules$ ssh leaf01
Linux leaf01 4.19.0-cl-1-amd64 #1 SMP Cumulus 4.19.94-1+cl4.2.1u1 (2020-08-28) x86_64
#########################################################
#Successfully logged in to: leaf01
##########################################################
#Last login: Fri Feb 19 17:23:03 2021 from 192.168.200.1
```

Verify EVPN VNI entries on leaf01/leaf02:
```
cumulus@leaf01:mgmt:~$ net show evpn vni
VNI        Type VxLAN IF              # MACs   # ARPs   # Remote VTEPs  Tenant VRF
20         L2   vni20                 7        8        2               RED
30         L2   vni30                 6        7        2               BLUE
10         L2   vni10                 7        8        0               RED
4001       L3   vniRED                2        4        n/a             RED
4002       L3   vniBLUE               1        2        n/a             BLUE
```
Note the RD/RT used:
```
cumulus@leaf01:mgmt:~$ net show bgp evpn vni
Advertise Gateway Macip: Disabled
Advertise SVI Macip: Disabled
Advertise All VNI flag: Enabled
BUM flooding: Head-end replication
Number of L2 VNIs: 3
Number of L3 VNIs: 2
Flags: * - Kernel
  VNI        Type RD                    Import RT                 Export RT                 Tenant VRF
* 20         L2   10.10.10.1:8          65101:20                  65101:20                 RED
* 30         L2   10.10.10.1:9          65101:30                  65101:30                 BLUE
* 10         L2   10.10.10.1:4          65101:10                  65101:10                 RED
* 4002       L3   10.10.10.1:2          65101:4002                65101:4002               BLUE
* 4001       L3   10.10.10.1:3          65101:4001                65101:4001               RED
```

EVPN Ethernet Segment details:
```
cumulus@leaf01:mgmt:~$ net sh evpn es
Type: B bypass, L local, R remote, N non-DF
ESI                            Type ES-IF                 VTEPs
03:44:38:39:be:ef:aa:00:00:01  LR   bond1                 10.10.10.2
03:44:38:39:be:ef:aa:00:00:02  LR   bond2                 10.10.10.2
03:44:38:39:be:ef:aa:00:00:03  LR   bond3                 10.10.10.2
03:44:38:39:be:ef:bb:00:00:01  R    -                     10.10.10.3,10.10.10.4
03:44:38:39:be:ef:bb:00:00:02  R    -                     10.10.10.3,10.10.10.4
03:44:38:39:be:ef:bb:00:00:03  R    -                     10.10.10.3,10.10.10.4
cumulus@leaf01:mgmt:~$ net sh evpn es-evi
Type: L local, R remote
VNI      ESI                            Type
20       03:44:38:39:be:ef:aa:00:00:02  L
30       03:44:38:39:be:ef:aa:00:00:03  L
10       03:44:38:39:be:ef:aa:00:00:01  L
```

Verify MAC entries are being learned on bridge of leaf01/leaf02:
```
cumulus@leaf01:mgmt:~$ net show bridge macs dynamic

VLAN      Master  Interface  MAC                TunnelDest   State   Flags               LastSeen
--------  ------  ---------  -----------------  -----------  ------  ------------------  ----------------
10        bridge  bond1      00:60:08:69:97:ef                                           00:00:22
10        bridge  bond1      96:65:45:6d:48:90               static                      00:01:16
10        bridge  vni10      6a:0f:31:ae:3d:7a                       extern_learn        2 days, 07:48:09
10        bridge  vni10      94:8e:1c:0d:77:93                       extern_learn        2 days, 07:48:09
10        bridge  vni10      96:8e:1c:0d:77:93                       extern_learn        2 days, 07:48:05
20        bridge  bond2      cc:6e:fa:8d:ff:92                                           00:00:25
20        bridge  bond2      f2:9d:d0:59:60:5d                                           00:00:22
20        bridge  vni20      00:60:08:69:97:ef                       extern_learn        2 days, 07:48:09
20        bridge  vni20      f8:4f:db:ef:be:8b                       extern_learn        2 days, 07:48:09
20        bridge  vni20      fa:4f:db:ef:be:8b                       extern_learn        2 days, 07:48:05
30        bridge  bond3      ea:77:bb:f1:a7:ca               static                      00:02:29
30        bridge  vni30      00:60:08:69:97:ef                       extern_learn        00:00:22
30        bridge  vni30      0a:2b:b9:d3:d7:84                       extern_learn        2 days, 07:48:09
30        bridge  vni30      2e:39:00:36:90:ba                       extern_learn        2 days, 07:48:09
4001      bridge  vniRED     44:38:39:be:ef:bb                       extern_learn        2 days, 07:47:51
4001      bridge  vniRED     44:38:39:be:ef:ff                       extern_learn        2 days, 07:48:06
4002      bridge  vniBLUE    44:38:39:be:ef:ff                       extern_learn        2 days, 07:48:08
untagged          vni10      6a:0f:31:ae:3d:7a                       self, extern_learn  2 days, 07:48:09
untagged          vni10      94:8e:1c:0d:77:93                       self, extern_learn  2 days, 07:48:09
untagged          vni10      96:8e:1c:0d:77:93                       self, extern_learn  2 days, 07:48:05
untagged          vni20      00:60:08:69:97:ef                       self, extern_learn  2 days, 07:48:09
untagged          vni20      f8:4f:db:ef:be:8b                       self, extern_learn  2 days, 07:48:09
untagged          vni20      fa:4f:db:ef:be:8b                       self, extern_learn  2 days, 07:48:05
untagged          vni30      00:60:08:69:97:ef                       self, extern_learn  00:00:22
untagged          vni30      0a:2b:b9:d3:d7:84                       self, extern_learn  2 days, 07:48:09
untagged          vni30      2e:39:00:36:90:ba                       self, extern_learn  2 days, 07:48:09
untagged          vniBLUE    44:38:39:be:ef:ff  10.10.10.63          self, extern_learn  2 days, 07:48:08
untagged          vniRED     44:38:39:be:ef:bb  10.10.10.4           self, extern_learn  2 days, 07:47:51
untagged          vniRED     44:38:39:be:ef:ff  10.10.10.63          self, extern_learn  2 days, 07:48:06
```

Verify neighbor entries are being learned on leaf01/leaf02:
```
cumulus@leaf01:mgmt:~$ net sh neighbor
Neighbor                   MAC                Interface  AF    STATE
-------------------------  -----------------  ---------  ----  ---------
169.254.0.1                ac:56:f0:f3:59:0c  swp54      IPv4  zebra
192.168.200.2              02:7a:19:45:66:48  eth0       IPv4  STALE
10.1.20.102                cc:6e:fa:8d:ff:92  vlan20     IPv4  REACHABLE
169.254.0.1                c0:99:6b:c0:e1:ca  swp52      IPv4  zebra
10.10.10.64                44:38:39:be:ef:ff  vlan4002   IPv4  zebra
192.168.200.250            44:38:39:00:01:80  eth0       IPv4  REACHABLE
10.10.10.64                44:38:39:be:ef:ff  vlan4001   IPv4  zebra
169.254.0.1                2c:f3:45:f4:6f:5f  swp53      IPv4  zebra
10.10.10.3                 44:38:39:be:ef:bb  vlan4001   IPv4  zebra
10.10.10.63                44:38:39:be:ef:ff  vlan4001   IPv4  zebra
192.168.200.1              12:72:bc:4c:e1:83  eth0       IPv4  REACHABLE
169.254.0.1                f0:08:5f:12:cc:8c  swp51      IPv4  zebra
10.10.10.4                 44:38:39:be:ef:bb  vlan4001   IPv4  zebra
10.10.10.63                44:38:39:be:ef:ff  vlan4002   IPv4  zebra
10.1.20.105                f8:4f:db:ef:be:8b  vlan20     IPv4  zebra
10.1.30.103                ea:77:bb:f1:a7:ca  vlan30     IPv4  REACHABLE
10.1.10.104                94:8e:1c:0d:77:93  vlan10     IPv4  zebra
10.1.10.101                96:65:45:6d:48:90  vlan10     IPv4  REACHABLE
fe80::2ef3:45ff:fef4:6f5f  2c:f3:45:f4:6f:5f  swp53      IPv6  REACHABLE
fe80::ae56:f0ff:fef3:590c  ac:56:f0:f3:59:0c  swp54      IPv6  REACHABLE
fe80::ce6e:faff:fe8d:ff92  cc:6e:fa:8d:ff:92  vlan20     IPv6  STALE
fe80::968e:1cff:fe0d:7793  94:8e:1c:0d:77:93  vlan10     IPv6  zebra
fe80::2c39:ff:fe36:90ba    2e:39:00:36:90:ba  vlan30     IPv6  zebra
fe80::7a:19ff:fe45:6648    02:7a:19:45:66:48  eth0       IPv6  REACHABLE
fe80::fa4f:dbff:feef:be8b  f8:4f:db:ef:be:8b  vlan20     IPv6  zebra
fe80::f208:5fff:fe12:cc8c  f0:08:5f:12:cc:8c  swp51      IPv6  REACHABLE
fe80::c299:6bff:fec0:e1ca  c0:99:6b:c0:e1:ca  swp52      IPv6  REACHABLE
fe80::9465:45ff:fe6d:4890  96:65:45:6d:48:90  vlan10     IPv6  zebra
fe80::ce6e:faff:fe8d:ff92  cc:6e:fa:8d:ff:92  vlan20-v0  IPv6  STALE
fe80::e877:bbff:fef1:a7ca  ea:77:bb:f1:a7:ca  vlan30     IPv6  zebra
```

Verify routes are learned over L3VNI for inter-VLAN routed peers:
```
cumulus@leaf01:mgmt:~$ net show route vrf RED
show ip route vrf RED
======================
Codes: K - kernel route, C - connected, S - static, R - RIP,
       O - OSPF, I - IS-IS, B - BGP, E - EIGRP, N - NHRP,
       T - Table, v - VNC, V - VNC-Direct, A - Babel, D - SHARP,
       F - PBR, f - OpenFabric,
       > - selected route, * - FIB route, q - queued route, r - rejected route


VRF RED:
K>* 0.0.0.0/0 [255/8192] unreachable (ICMP unreachable), 02w4d09h
C * 10.1.10.0/24 [0/1024] is directly connected, vlan10-v0, 01w5d11h
C>* 10.1.10.0/24 is directly connected, vlan10, 01w5d11h
B>* 10.1.10.104/32 [20/0] via 10.10.10.3, vlan4001 onlink, weight 1, 2d07h47m
  *                       via 10.10.10.4, vlan4001 onlink, weight 1, 2d07h47m
C * 10.1.20.0/24 [0/1024] is directly connected, vlan20-v0, 01w5d11h
C>* 10.1.20.0/24 is directly connected, vlan20, 01w5d11h
B>* 10.1.20.105/32 [20/0] via 10.10.10.3, vlan4001 onlink, weight 1, 2d07h47m
  *                       via 10.10.10.4, vlan4001 onlink, weight 1, 2d07h47m
B>* 10.1.30.0/24 [20/0] via 10.10.10.63, vlan4001 onlink, weight 1, 2d07h49m
  *                     via 10.10.10.64, vlan4001 onlink, weight 1, 2d07h49m
B>* 10.1.101.4/32 [20/0] via 10.10.10.63, vlan4001 onlink, weight 1, 04:30:24



show ipv6 route vrf RED
========================
Codes: K - kernel route, C - connected, S - static, R - RIPng,
       O - OSPFv3, I - IS-IS, B - BGP, N - NHRP, T - Table,
       v - VNC, V - VNC-Direct, A - Babel, D - SHARP, F - PBR,
       f - OpenFabric,
       > - selected route, * - FIB route, q - queued route, r - rejected route


VRF RED:
K>* ::/0 [255/8192] unreachable (ICMP unreachable), 02w4d09h
C * fe80::/64 is directly connected, vlan4001, 01w5d11h
C * fe80::/64 is directly connected, vlan20-v0, 01w5d11h
C * fe80::/64 is directly connected, vlan20, 01w5d11h
C * fe80::/64 is directly connected, vlan10-v0, 01w5d11h
C>* fe80::/64 is directly connected, vlan10, 01w5d11h
K>* ff00::/8 [0/256] is directly connected, vlan4001, 02w4d09h
```

Check the neighbor table for the specific mac under ip address 10.1.20.105:
```
cumulus@leaf01:mgmt:~$ net sh neighbor 10.1.20.105
Neighbor     MAC                Interface  AF    STATE
-----------  -----------------  ---------  ----  -----
10.1.20.105  f8:4f:db:ef:be:8b  vlan20     IPv4  zebra
```

Check the BGP routing table for the MAC/IP route (mac f8:4f:db:ef:be:8b ip 10.1.20.105):
```
cumulus@leaf01:mgmt:~$ net show bgp l2vpn evpn route vni 20 mac f8:4f:db:ef:be:8b ip 10.1.20.105
BGP routing table entry for [2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105]
Paths: (8 available, best #8)
  Not advertised to any peer
  Route [2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105] VNI 20/4001
  Imported from 10.10.10.4:8:[2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105], VNI 20/4001
  65100 65104
    10.10.10.4 from spine04(swp54) (10.10.10.104)
      ESI 03:44:38:39:be:ef:bb:00:00:02
      Origin IGP, valid, external
      Extended Community: RT:65104:20 RT:65104:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:18:58 2021
  Route [2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105] VNI 20/4001
  Imported from 10.10.10.4:8:[2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105], VNI 20/4001
  65100 65104
    10.10.10.4 from spine02(swp52) (10.10.10.102)
      ESI 03:44:38:39:be:ef:bb:00:00:02
      Origin IGP, valid, external
      Extended Community: RT:65104:20 RT:65104:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:18:58 2021
  Route [2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105] VNI 20/4001
  Imported from 10.10.10.4:8:[2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105], VNI 20/4001
  65100 65104
    10.10.10.4 from spine01(swp51) (10.10.10.101)
      ESI 03:44:38:39:be:ef:bb:00:00:02
      Origin IGP, valid, external
      Extended Community: RT:65104:20 RT:65104:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:18:58 2021
  Route [2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105] VNI 20/4001
  Imported from 10.10.10.4:8:[2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105], VNI 20/4001
  65100 65104
    10.10.10.4 from spine03(swp53) (10.10.10.103)
      ESI 03:44:38:39:be:ef:bb:00:00:02
      Origin IGP, valid, external
      Extended Community: RT:65104:20 RT:65104:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:18:58 2021
  Route [2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105] VNI 20/4001
  Imported from 10.10.10.3:8:[2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105], VNI 20/4001
  65100 65103
    10.10.10.3 from spine02(swp52) (10.10.10.102)
      ESI 03:44:38:39:be:ef:bb:00:00:02
      Origin IGP, valid, external
      Extended Community: RT:65103:20 RT:65103:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:17:42 2021
  Route [2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105] VNI 20/4001
  Imported from 10.10.10.3:8:[2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105], VNI 20/4001
  65100 65103
    10.10.10.3 from spine01(swp51) (10.10.10.101)
      ESI 03:44:38:39:be:ef:bb:00:00:02
      Origin IGP, valid, external
      Extended Community: RT:65103:20 RT:65103:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:17:42 2021
  Route [2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105] VNI 20/4001
  Imported from 10.10.10.3:8:[2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105], VNI 20/4001
  65100 65103
    10.10.10.3 from spine03(swp53) (10.10.10.103)
      ESI 03:44:38:39:be:ef:bb:00:00:02
      Origin IGP, valid, external
      Extended Community: RT:65103:20 RT:65103:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:17:42 2021
  Route [2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105] VNI 20/4001
  Imported from 10.10.10.3:8:[2]:[0]:[48]:[f8:4f:db:ef:be:8b]:[32]:[10.1.20.105], VNI 20/4001
  65100 65103
    10.10.10.3 from spine04(swp54) (10.10.10.104)
      ESI 03:44:38:39:be:ef:bb:00:00:02
      Origin IGP, valid, external, bestpath-from-AS 65100, best (EVPN lower IP)
      Extended Community: RT:65103:20 RT:65103:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:17:42 2021

Displayed 8 paths for requested prefix
```

Check the neighbor table for the specific mac under ip address 10.1.10.104:
```
cumulus@leaf01:mgmt:~$ net sh neighbor 10.1.10.104
Neighbor     MAC                Interface  AF    STATE
-----------  -----------------  ---------  ----  -----
10.1.10.104  94:8e:1c:0d:77:93  vlan10     IPv4  zebra
```

Check the BGP routing table for the MAC/IP route (mac 94:8e:1c:0d:77:93 ip 10.1.10.104):
```
cumulus@leaf01:mgmt:~$ net show bgp l2vpn evpn route vni 10 mac 94:8e:1c:0d:77:93 ip 10.1.10.104
BGP routing table entry for [2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104]
Paths: (8 available, best #8)
  Not advertised to any peer
  Route [2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104] VNI 10/4001
  Imported from 10.10.10.4:9:[2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104], VNI 10/4001
  65100 65104
    10.10.10.4 from spine03(swp53) (10.10.10.103)
      ESI 03:44:38:39:be:ef:bb:00:00:01
      Origin IGP, valid, external
      Extended Community: RT:65104:10 RT:65104:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:19:06 2021
  Route [2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104] VNI 10/4001
  Imported from 10.10.10.4:9:[2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104], VNI 10/4001
  65100 65104
    10.10.10.4 from spine04(swp54) (10.10.10.104)
      ESI 03:44:38:39:be:ef:bb:00:00:01
      Origin IGP, valid, external
      Extended Community: RT:65104:10 RT:65104:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:19:06 2021
  Route [2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104] VNI 10/4001
  Imported from 10.10.10.4:9:[2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104], VNI 10/4001
  65100 65104
    10.10.10.4 from spine02(swp52) (10.10.10.102)
      ESI 03:44:38:39:be:ef:bb:00:00:01
      Origin IGP, valid, external
      Extended Community: RT:65104:10 RT:65104:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:19:06 2021
  Route [2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104] VNI 10/4001
  Imported from 10.10.10.4:9:[2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104], VNI 10/4001
  65100 65104
    10.10.10.4 from spine01(swp51) (10.10.10.101)
      ESI 03:44:38:39:be:ef:bb:00:00:01
      Origin IGP, valid, external
      Extended Community: RT:65104:10 RT:65104:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:19:06 2021
  Route [2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104] VNI 10/4001
  Imported from 10.10.10.3:9:[2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104], VNI 10/4001
  65100 65103
    10.10.10.3 from spine03(swp53) (10.10.10.103)
      ESI 03:44:38:39:be:ef:bb:00:00:01
      Origin IGP, valid, external
      Extended Community: RT:65103:10 RT:65103:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:17:44 2021
  Route [2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104] VNI 10/4001
  Imported from 10.10.10.3:9:[2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104], VNI 10/4001
  65100 65103
    10.10.10.3 from spine04(swp54) (10.10.10.104)
      ESI 03:44:38:39:be:ef:bb:00:00:01
      Origin IGP, valid, external
      Extended Community: RT:65103:10 RT:65103:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:17:44 2021
  Route [2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104] VNI 10/4001
  Imported from 10.10.10.3:9:[2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104], VNI 10/4001
  65100 65103
    10.10.10.3 from spine02(swp52) (10.10.10.102)
      ESI 03:44:38:39:be:ef:bb:00:00:01
      Origin IGP, valid, external
      Extended Community: RT:65103:10 RT:65103:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:17:44 2021
  Route [2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104] VNI 10/4001
  Imported from 10.10.10.3:9:[2]:[0]:[48]:[94:8e:1c:0d:77:93]:[32]:[10.1.10.104], VNI 10/4001
  65100 65103
    10.10.10.3 from spine01(swp51) (10.10.10.101)
      ESI 03:44:38:39:be:ef:bb:00:00:01
      Origin IGP, valid, external, bestpath-from-AS 65100, best (EVPN lower IP)
      Extended Community: RT:65103:10 RT:65103:4001 ET:8 MM:2 Rmac:44:38:39:be:ef:bb
      Last update: Fri Feb 19 17:17:44 2021

Displayed 8 paths for requested prefix
```
<!-- AIR:tour -->
